Package: densvis
Title: Density-Preserving Data Visualization via Non-Linear
        Dimensionality Reduction
Version: 1.22.0
Date: 2025-11-04
Authors@R: 
  c(
    person(
      given = "Alan",
      family = "O'Callaghan",
      role = c("aut", "cre"),
      email = "alan.ocallaghan@outlook.com"
    ),
    person(given = "Ashwinn", family = "Narayan", role = "aut"),
    person(given = "Hyunghoon", family = "Cho", role = "aut")
  )
Description: 
  Implements the density-preserving modification to t-SNE 
  and UMAP described by Narayan et al. (2020) 
  <doi:10.1101/2020.05.12.077776>.
  The non-linear dimensionality reduction techniques t-SNE and UMAP
  enable users to summarise complex high-dimensional sequencing data
  such as single cell RNAseq using lower dimensional representations. 
  These lower dimensional representations enable the visualisation of discrete
  transcriptional states, as well as continuous trajectory (for example, in 
  early development). However, these methods focus on the local neighbourhood 
  structure of the data. In some cases, this results in
  misleading visualisations, where the density of cells in the low-dimensional
  embedding does not represent the transcriptional heterogeneity of data in the 
  original high-dimensional space. den-SNE and densMAP aim to enable more 
  accurate visual interpretation of high-dimensional datasets by producing 
  lower-dimensional embeddings that accurately represent the heterogeneity of 
  the original high-dimensional space, enabling the identification of 
  homogeneous and heterogeneous cell states.
  This accuracy is accomplished by including in the optimisation process a term
  which considers the local density of points in the original high-dimensional 
  space. This can help to create visualisations that are more representative of 
  heterogeneity in the original high-dimensional space.
License: MIT + file LICENSE
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.2.3
Imports: Rcpp, basilisk, assertthat, reticulate, Rtsne, irlba
Suggests: knitr, rmarkdown, BiocStyle, ggplot2, uwot, testthat
BugReports: https://github.com/Alanocallaghan/densvis/issues
LinkingTo: Rcpp
biocViews: DimensionReduction, Visualization, Software, SingleCell,
        Sequencing
VignetteBuilder: knitr
URL: https://bioconductor.org/packages/densvis
StagedInstall: no
git_url: https://git.bioconductor.org/packages/densvis
git_branch: RELEASE_3_23
git_last_commit: 32fc121
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 21:42:47 UTC; biocbuild
Author: Alan O'Callaghan [aut, cre],
  Ashwinn Narayan [aut],
  Hyunghoon Cho [aut]
Maintainer: Alan O'Callaghan <alan.ocallaghan@outlook.com>

python_env <- BasiliskEnvironment(
    "densvis",
    pkgname = "densvis",
    packages = c(
        "python=3.12.10",
        "umap-learn=0.5.9.post2",
        "scikit-learn=1.7.0",
        "numba=0.62.0",
        "pynndescent=0.5.13",
        "scipy=1.16.0",
        "numpy=2.3.4",
        "llvmlite=0.45.0"
    )
)

#' Density-preserving t-SNE
#'
#' @param X Input data matrix, where rows are observations and columns are
#' features.
#' @param dims Integer output dimensionality.
#' @param perplexity Perplexity parameter (should not be bigger than 
#'  3 * perplexity < nrow(X) - 1).
#' @param theta Speed/accuracy trade-off (increase for less
#'  accuracy), set to 0.0 for exact TSNE 
#' @param check_duplicates logical; Checks whether duplicates are present.
#' It is best to make sure there are no duplicates present and set this option
#' to FALSE, especially for large datasets (default: TRUE)
#' @param pca logical; Whether an initial PCA step should be performed
#' (default: FALSE).
#' @param initial_dims integer; the number of dimensions that should be retained
#' in the initial PCA step (default: 50)
#' @param partial_pca logical; Whether truncated PCA should be used to calculate
#' principal components (requires the irlba package). This is faster for large
#' input matrices (default: FALSE)
#' @param pca_center,pca_scale Controls whether to centre and scale the data
#' before applying PCA. Defaults: TRUE, FALSE.
#' @param verbose Logical; Whether progress updates should be printed 
#' @param max_iter integer; Number of iterations
#' @param Y_init matrix; Initial locations of the objects. If NULL, random
#' initialization will be used 
#' @param stop_lying_iter integer; Iteration after which the perplexities are no
#'  longer exaggerated 
#' @param mom_switch_iter integer; Iteration after which the final momentum is
#'  used
#' @param momentum numeric; Momentum used in the first part of the optimization
#' @param final_momentum numeric; Momentum used in the final part of the 
#'  optimization
#' @param eta numeric; Learning rate
#' @param exaggeration_factor numeric; Exaggeration factor used to multiply the
#'  affinities matrix P in the first part of the optimization
#' @param dens_frac numeric; fraction of the iterations for which the full 
#'  objective function (including the density-preserving term) is used.
#'  For the first \code{1 - dens_frac} fraction of the iterations, only
#'  the original t-SNE objective function is used.
#' @param dens_lambda numeric; the relative importanceof the 
#'  density-preservation term compared to the original t-SNE objective function.
#' @param num_threads Number of threads to be used for parallelisation.
#' @param normalize logical; Should data be normalized internally prior to 
#' distance calculations with \code{\link[Rtsne]{normalize_input}}?
#' @return A numeric matrix corresponding to the t-SNE embedding 
#' @references
#' Density-Preserving Data Visualization Unveils Dynamic Patterns of Single-Cell 
#' Transcriptomic Variability
#' Ashwin Narayan, Bonnie Berger, Hyunghoon Cho;
#' bioRxiv (2020)
#' <doi:10.1101/2020.05.12.077776>
#' @importFrom stats prcomp
#' @examples 
#' x <- matrix(rnorm(1e3), nrow = 100)
#' d <- densne(x, perplexity = 5)
#' plot(d)
#' @export
densne <- function(
        X,
        dims = 2,
        perplexity = 50,
        theta = 0.5,
        check_duplicates = TRUE,
        pca = FALSE,
        initial_dims = 50,
        partial_pca = FALSE,
        pca_center = TRUE,
        pca_scale = FALSE,
        verbose = getOption("verbose", FALSE),
        max_iter = 1000,
        Y_init = NULL,
        stop_lying_iter = if (is.null(Y_init)) 250L else 0L, 
        mom_switch_iter = if (is.null(Y_init)) 250L else 0L, 
        momentum = 0.5,
        final_momentum = 0.8,
        eta = 200,
        exaggeration_factor = 12,
        dens_frac = 0.3,
        dens_lambda = 0.1,
        num_threads = 1,
        normalize = TRUE
    ) {
    X <- as.matrix(X)
    if (normalize) {
      X <- Rtsne::normalize_input(X)
    }
    .check_tsne_params(
        X = X,
        nsamples = nrow(X),
        dims = dims,
        perplexity = perplexity,
        theta = theta,
        check_duplicates = check_duplicates,
        pca = pca,
        initial_dims = initial_dims,
        partial_pca = partial_pca,
        pca_center = pca_center,
        pca_scale = pca_scale,
        max_iter = max_iter,
        verbose = verbose, 
        Y_init = Y_init,
        stop_lying_iter = stop_lying_iter,
        mom_switch_iter = mom_switch_iter, 
        momentum = momentum,
        final_momentum = final_momentum,
        eta = eta,
        dens_frac = dens_frac,
        dens_lambda = dens_lambda,
        exaggeration_factor = exaggeration_factor
    )
    if (pca) {
      if (verbose) cat("Performing PCA\n")
      if (partial_pca) {
        if (!requireNamespace("irlba", quietly = TRUE)) {
            stop("Package \"irlba\" is required for partial PCA. Please install it.", call. = FALSE)
        }
        X <- irlba::prcomp_irlba(X, n = initial_dims, center = pca_center, scale = pca_scale)$x
      } else {
        if (verbose & min(dim(X))>2500) {
            cat("Consider setting partial_pca=TRUE for large matrices\n")
        }
        X <- prcomp(X, retx=TRUE, center = pca_center, scale. = pca_scale, rank. = initial_dims)$x
      }
    }
    X <- t(X)
    out <- densne_cpp(
        X = X,
        no_dims = dims,
        perplexity = perplexity,
        theta = theta,
        verbose = verbose,
        max_iter = max_iter,
        Y_in = if (is.null(Y_init)) matrix() else Y_init,
        init = !is.null(Y_init),
        stop_lying_iter = stop_lying_iter,
        mom_switch_iter = mom_switch_iter,
        momentum = momentum,
        final_momentum = final_momentum,
        eta = eta,
        exaggeration_factor = exaggeration_factor,
        dens_frac = dens_frac,
        dens_lambda = dens_lambda,
        final_dens = FALSE,
        num_threads = num_threads
    )
    t(out)
}


.check_tsne_params <- function(
        X,
        nsamples,
        dims,
        perplexity,
        theta,
        check_duplicates,
        pca,
        initial_dims,
        partial_pca,
        pca_center,
        pca_scale,
        max_iter,
        verbose,
        Y_init,
        stop_lying_iter,
        mom_switch_iter,
        dens_lambda,
        dens_frac,
        momentum,
        final_momentum,
        eta,
        exaggeration_factor) {

    # if (!is.wholenumber(dims) || dims < 1 || dims > 3) {
    #     stop("dims should be either 1, 2 or 3")
    # }
    if (!is.wholenumber(max_iter) || !(max_iter>0)) {
        stop("number of iterations should be a positive integer")
    }
    if (!is.null(Y_init) && (nsamples != nrow(Y_init) || ncol(Y_init) != dims)) {
        stop("incorrect format for Y_init")
    }
    if (!is.logical(pca) & length(pca) == 1) {
        stop("pca should be a logical scalar.")
    }
    if (!is.wholenumber(initial_dims) & length(initial_dims) == 1) {
        stop("pca should be an single whole number.")
    }
    if (!is.logical(partial_pca) & length(partial_pca) == 1) {
        stop("partial_pca should be a logical scalar.")
    }
    if (!is.logical(pca_center) & length(pca_center) == 1) {
        stop("pca_center should be a logical scalar.")
    }
    if (!is.logical(pca_scale) & length(pca_scale) == 1) {
        stop("pca_scale should be a logical scalar.")
    }
    if (!is.numeric(perplexity) || perplexity <= 0) {
        stop("perplexity should be a positive number")
    }
    if (!is.numeric(theta) || (theta < 0.0) || (theta > 1.0) ) {
        stop("theta should lie in [0, 1]")
    }
    if (!is.numeric(dens_frac) || (dens_frac < 0.0) || (dens_frac > 1.0) ) {
        stop("dens_frac should lie in [0, 1]")
    }
    if (!is.numeric(dens_lambda) || (dens_lambda < 0.0) || (dens_lambda > 1.0) ) {
        stop("dens_lambda should lie in [0, 1]")
    }
    if (!is.wholenumber(stop_lying_iter) || stop_lying_iter < 0) {
        stop("stop_lying_iter should be a positive integer")
    }
    if (!is.wholenumber(mom_switch_iter) || mom_switch_iter < 0) {
        stop("mom_switch_iter should be a positive integer")
    }
    if (!is.numeric(momentum) || momentum < 0) {
        stop("momentum should be a positive number")
    }
    if (!is.numeric(final_momentum) || final_momentum < 0) {
        stop("final_momentum should be a positive number")
    }
    if (!is.numeric(eta) || eta <= 0) {
        stop("eta should be a positive number")
    }
    if (!is.numeric(exaggeration_factor) || exaggeration_factor <= 0) {
        stop("exaggeration_factor should be a positive number")
    }
    if (nsamples - 1 < 3 * perplexity) {
        stop("perplexity is too large for the number of samples")
    }

    init <- !is.null(Y_init)
    if (init) {
        Y_init <- t(Y_init) # transposing for rapid column-major access.
    } else {
        Y_init <- matrix()
    }
    if (check_duplicates) {
      if (any(duplicated(X))) { stop("Remove duplicates before running TSNE.") }
    }
    list(
        no_dims = dims,
        perplexity = perplexity,
        theta = theta,
        max_iter = max_iter,
        verbose = verbose,
        init = init,
        Y_init = Y_init,
        stop_lying_iter = stop_lying_iter,
        mom_switch_iter = mom_switch_iter,
        momentum = momentum,
        final_momentum = final_momentum,
        eta = eta,
        dens_lambda = dens_lambda,
        dens_frac = dens_frac,
        exaggeration_factor = exaggeration_factor
    )
}


is.wholenumber <- function(x, tol = .Machine$double.eps^0.5) {
    (is.numeric(x) | is.integer(x)) & abs(x - round(x)) < tol
}

test_that("error conditions", {
    x <- matrix(rnorm(1e3), nrow = 100)
    x <- x[1:10, ]
    expect_error(densne(x), "perplexity is too large for the number of samples")
    expect_error(
        densne(x, max_iter=-1),
        "number of iterations should be a positive integer"
    )
    expect_error(
        densne(x, perplexity = -1),
        "perplexity should be a positive number"
    )
    expect_error(
        densne(x, exaggeration_factor = -1),
        "exaggeration_factor should be a positive number"
    )
    expect_error(
        densne(x, momentum = -1),
        "momentum should be a positive number"
    )
    expect_error(
        densne(x, eta = -1),
        "eta should be a positive number"
    )
    expect_error(
        densne(x, final_momentum = -1),
        "final_momentum should be a positive number"
    )
    expect_error(
        densne(x, mom_switch_iter = -1),
        "mom_switch_iter should be a positive integer"
    )
    expect_error(
        densne(x, stop_lying_iter = -1),
        "stop_lying_iter should be a positive integer"
    )
    expect_error(
        densne(x, dens_frac = 1.1),
        "dens_frac should lie in \\[0, 1\\]"
    )
    expect_error(
        densne(x, dens_lambda = 1.1),
        "dens_lambda should lie in \\[0, 1\\]"
    )
    expect_error(
        densne(x, theta = 1.1),
        "theta should lie in \\[0, 1\\]"
    )
})

test_that("densne works", {
    x <- matrix(rnorm(1e3), nrow = 100)
    expect_is(densne(x, perplexity = 5), "matrix")
    expect_is(densne(x, perplexity = 5, num_threads = 8), "matrix")
    Y_init <- prcomp(x)$x[, 1:2]
    expect_is(densne(x, perplexity = 5, Y_init = Y_init), "matrix")
})

#' @importFrom Rcpp sourceCpp
#' @useDynLib densvis
NULL

#' @importFrom reticulate py_to_r py_to_r_wrapper import
#' @importFrom assertthat assert_that
#' @importFrom basilisk BasiliskEnvironment basiliskStart basiliskRun basiliskStop
NULL

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

densne_cpp <- function(X, no_dims, perplexity, theta, verbose, max_iter, Y_in, init, stop_lying_iter, mom_switch_iter, momentum, final_momentum, eta, exaggeration_factor, dens_frac, dens_lambda, final_dens, num_threads) {
    .Call('_densvis_densne_cpp', PACKAGE = 'densvis', X, no_dims, perplexity, theta, verbose, max_iter, Y_in, init, stop_lying_iter, mom_switch_iter, momentum, final_momentum, eta, exaggeration_factor, dens_frac, dens_lambda, final_dens, num_threads)
}

#' Density-preserving and other implementations of UMAP
#' 
#' @param x A numeric matrix or matrix-like object.
#' @param n_components The dimension of the space to embed 
#' into. This defaults to 2 to provide easy visualization, 
#' but can reasonably be set to any integer value in the 
#' range 2 to 100.
#' @param densmap For \code{umap}, control whether the density-preserving
#' UMAP algorithm described by Narayan et al. is used.
#' @param dens_frac numeric; fraction of the iterations for
#' which the full objective function (including the 
#' density-preserving term) is used. For the first 
#' \code{1 - dens_frac} fraction of the iterations, only
#' the original t-SNE objective function is used.
#' Only takes effect when \code{densmap=TRUE}.
#' @param dens_lambda numeric; the relative importance of the 
#' density-preservation term compared to the original t-SNE 
#' objective function.
#' Only takes effect when \code{densmap=TRUE}.
#' @param dens_var_shift Regularization term added to the variance 
#' of embedding local radius for stability (float, 
#' non-negative); default 0.1.
#' Only takes effect when \code{densmap=TRUE}.
#' @param n_neighbors The size of local neighborhood 
#' (in terms of number of neighboring sample points) used for 
#' manifold approximation. Larger values result in more 
#' global views of the manifold, while smaller values result 
#' in more local data being preserved. In general values 
#' should be in the range 2 to 100.
#' @param metric The metric to use to compute distances in 
#' high dimensional space. If a string is passed it must match
#' one of:
#' - "euclidean"
#' - "manhattan"
#' - "chebyshev"
#' - "minkowski"
#' - "canberra"
#' - "braycurtis"
#' - "mahalanobis"
#' - "wminkowski"
#' - "seuclidean"
#' - "cosine"
#' - "correlation"
#' - "haversine"
#' - "hamming"
#' - "jaccard"
#' - "dice"
#' - "russelrao"
#' - "kulsinski"
#' - "rogerstanimoto"
#' - "sokalmichener"
#' - "sokalsneath"
#' - "yule"
#' @param n_epochs The number of training epochs to be used 
#' in optimizing the low dimensional embedding. Larger values 
#' result in more accurate embeddings. If None is specified a 
#' value will be selected based on the size of the input 
#' dataset (200 for large datasets, 500 for small).
#' a valid predefined metric.
#' @param learning_rate The initial learning rate for the embedding optimization.
#' @param init How to initialize the low dimensional 
#' embedding. Valid options:
#' - "spectral": use a spectral embedding of the fuzzy 1-skeleton
#' - "random": assign initial embedding positions at random.
#' @param Y_init Numeric matrix specifying the initial 
#' locations of the objects in the embedding. If NULL, 
#' random or spectral initialization will be used,
#' controlled by the \code{init} argument.
#' @param min_dist The effective minimum distance between 
#' embedded points. Smaller values will result in a more 
#' clustered/clumped embedding where nearby points on the 
#' manifold are drawn closer together, while larger values 
#' will result on a more even dispersal of points. The value 
#' should be set relative to the spread value, which 
#' determines the scale at which embedded points will be 
#' spread out.
#' @param spread The effective scale of embedded points. In combination with 
#' min_dist this determines how clustered/clumped the embedded points are.
#' @param low_memory For some datasets the nearest neighbor computation can
#' consume a lot of memory. If you find that UMAP is failing due to memory
#' constraints consider setting this option to True. This approach is more
#' computationally expensive, but avoids excessive memory use.
#' @param set_op_mix_ratio Interpolate between (fuzzy) union 
#' and intersection as the set operation used to combine 
#' local fuzzy simplicial sets to obtain a global fuzzy 
#' simplicial sets. Both fuzzy set operations use the product 
#' t-norm. The value of this parameter should be between 0.0 
#' and 1.0; a value of 1.0 will use a pure fuzzy union, while 
#' 0.0 will use a pure fuzzy intersection.
#' @param local_connectivity The local connectivity required 
#' – i.e. the number of nearest neighbors that should be 
#' assumed to be connected at a local level. The higher this 
#' value the more connected the manifold becomes locally. In 
#' practice this should be not more than the local intrinsic 
#' dimension of the manifold.
#' @param repulsion_strength Weighting applied to negative 
#' samples in low dimensional embedding optimization. Values 
#' higher than one will result in greater weight being given 
#' to negative samples.
#' @param negative_sample_rate The number of negative samples 
#' to select per positive sample in the optimization process. 
#' Increasing this value will result in greater repulsive 
#' force being applied, greater optimization cost, but 
#' slightly more accuracy.
#' @param transform_queue_size For transform operations 
#' (embedding new points using a trained model_ this will 
#' control how aggressively to search for nearest neighbors. 
#' Larger values will result in slower performance but more 
#' accurate nearest neighbor evaluation.
#' @param random_state The seed used by the random number 
#' generator.
#' @param angular_rp_forest Whether to use an angular random 
#' projection forest to initialise the approximate nearest 
#' neighbor search. This can be faster, but is mostly on 
#' useful for metric that use an angular style distance such 
#' as cosine, correlation etc. In the case of those metrics 
#' angular forests will be chosen automatically.
#' @param target_n_neighbors The number of nearest neighbors 
#' to use to construct the target simplcial set. If set to -1 
#' use the n_neighbors value.
#' @param target_weight Weighting factor between data 
#' topology and target topology. A value of 0.0 weights 
#' entirely on data, a value of 1.0 weights entirely on 
#' target. The default of 0.5 balances the weighting equally 
#' between data and target.
#' @param disconnection_distance Numeric scalar.
#' If specified, UMAP will disconnect any vertices of distance greater than or
#' equal to disconnection_distance when approximating the manifold via our k-nn 
#' graph. This is particularly useful in the case that you have a bounded 
#' metric. The UMAP assumption that we have a connected manifold can be 
#' problematic when you have points that are maximally different from all the 
#' rest of your data. The connected manifold assumption will make such points 
#' have perfect similarity to a random set of other points. Too many such 
#' points will artificially connect your space.
#' @param ... Passed from \code{densmap} to \code{umap}.
#' @return A numeric matrix
#' @references
#' Density-Preserving Data Visualization Unveils Dynamic Patterns of Single-Cell 
#' Transcriptomic Variability
#' Ashwin Narayan, Bonnie Berger, Hyunghoon Cho;
#' bioRxiv (2020)
#' <doi:10.1101/2020.05.12.077776>
#' @examples
#' set.seed(42)
#' x <- matrix(rnorm(200), ncol=2)
#' densmap(x)
#' @export
#' @rdname densmap
umap <- function(
        x,
        n_components = 2L,
        dens_frac = 0.3,
        dens_lambda = 0.1,
        dens_var_shift = 0.1,
        n_neighbors = 30L,
        metric = "euclidean",
        densmap = FALSE,
        n_epochs = 750L,
        learning_rate = 1.0,
        init = c("spectral", "random"),
        Y_init = NULL,
        min_dist = 0.1,
        spread = 1.0,
        low_memory = FALSE,
        set_op_mix_ratio = 1.0,
        local_connectivity = 1L,
        repulsion_strength = 1.0,
        negative_sample_rate = 5L,
        transform_queue_size = 4.0,
        random_state = NULL,
        angular_rp_forest = FALSE,
        target_n_neighbors = -1,
        target_weight = 0.5,
        disconnection_distance = NULL
    ) {
    x <- as.matrix(x)
    init <- match.arg(init)
    if (!is.null(Y_init)) {
        assert_that(
            is.matrix(Y_init),
            is.numeric(Y_init),
            ncol(Y_init) == n_components,
            nrow(Y_init) == nrow(x)
        )
        init <- Y_init
    }
    .checks(
        x = x,
        n_components = n_components,
        dens_frac = dens_frac,
        dens_lambda = dens_lambda,
        n_neighbors = n_neighbors,
        metric = metric,
        n_epochs = n_epochs,
        dens_var_shift = dens_var_shift,
        learning_rate = learning_rate,
        init = init,
        min_dist = min_dist,
        spread = spread,
        low_memory = low_memory,
        set_op_mix_ratio = set_op_mix_ratio,
        local_connectivity = local_connectivity,
        repulsion_strength = repulsion_strength,
        negative_sample_rate = negative_sample_rate,
        transform_queue_size = transform_queue_size,
        random_state = random_state,
        angular_rp_forest = angular_rp_forest,
        target_n_neighbors = target_n_neighbors,
        target_weight = target_weight
    )
    proc <- basiliskStart(python_env)
    on.exit(basiliskStop(proc))

    if (!is.null(random_state)) {
        random_state <- as.integer(random_state)
    }
    out <- basiliskRun(proc, .fit_umap,
        x = x, 
        n_components = as.integer(n_components),
        dens_frac = dens_frac,
        dens_lambda = dens_lambda,
        densmap = densmap,
        n_neighbors = as.integer(n_neighbors),
        metric = metric,
        n_epochs = as.integer(n_epochs),
        dens_var_shift = dens_var_shift,
        learning_rate = learning_rate,
        init = init,
        min_dist = min_dist,
        spread = spread,
        low_memory = low_memory,
        set_op_mix_ratio = set_op_mix_ratio,
        local_connectivity = as.integer(local_connectivity),
        repulsion_strength = repulsion_strength,
        negative_sample_rate = as.integer(negative_sample_rate),
        transform_queue_size = transform_queue_size,
        random_state = random_state,
        angular_rp_forest = angular_rp_forest,
        target_n_neighbors = target_n_neighbors,
        target_weight = target_weight
    )
    out

}

.fit_umap <- function(x, densmap = TRUE, ...) {
    umap <- reticulate::import("umap")
    umap$UMAP(
        densmap = densmap,
        output_dens = FALSE,
        ...
    )$fit_transform(x)
}

#' @rdname densmap
#' @export
densmap <- function(...) {
    umap(..., densmap = TRUE)
}


.checks <- function(
        x,
        n_components,
        dens_frac,
        dens_lambda,
        dens_var_shift,
        n_neighbors,
        metric,
        n_epochs,
        learning_rate,
        init,
        min_dist,
        spread,
        low_memory,
        set_op_mix_ratio,
        local_connectivity,
        repulsion_strength,
        negative_sample_rate,
        transform_queue_size,
        random_state,
        angular_rp_forest,
        target_n_neighbors,
        target_weight
    ) {
    match.arg(metric,
        choices = c(
            "euclidean",
            "manhattan",
            "chebyshev",
            "minkowski",
            "canberra",
            "braycurtis",
            "mahalanobis",
            "wminkowski",
            "seuclidean",
            "cosine",
            "correlation",
            "haversine",
            "hamming",
            "jaccard",
            "dice",
            "russelrao",
            "kulsinski",
            "rogerstanimoto",
            "sokalmichener",
            "sokalsneath",
            "yule"
        )
    )
    assert_that(
        # is.integer(n_components),
        round(n_components) == n_components,
        n_components > 0,
        length(n_components) == 1,
        is.numeric(dens_frac),
        dens_frac >= 0,
        dens_frac <= 1,
        is.numeric(dens_lambda),
        dens_lambda >= 0,
        dens_lambda <= 1,
        n_neighbors > 0,
        # is.integer(n_neighbors),
        round(n_neighbors) == n_neighbors,
        length(n_neighbors) == 1,
        # is.integer(n_epochs),
        round(n_epochs) == n_epochs,
        n_epochs > 0,
        length(n_epochs) == 1,
        is.numeric(dens_var_shift),
        dens_var_shift > 0,
        length(dens_var_shift) == 1,
        is.numeric(learning_rate),
        learning_rate > 0,
        length(learning_rate) == 1,
        is.numeric(min_dist),
        min_dist > 0,
        length(min_dist) == 1,
        is.numeric(spread),
        spread > 0,
        length(spread) == 1,
        is.numeric(set_op_mix_ratio),
        set_op_mix_ratio > 0,
        length(set_op_mix_ratio) == 1,
        # is.integer(local_connectivity),
        round(local_connectivity) == local_connectivity,
        local_connectivity > 0,
        length(local_connectivity) == 1,
        is.numeric(repulsion_strength),
        repulsion_strength > 0,
        length(repulsion_strength) == 1,
        # is.integer(negative_sample_rate),
        round(negative_sample_rate) == negative_sample_rate,
        negative_sample_rate > 0,
        length(negative_sample_rate) == 1,
        is.numeric(transform_queue_size),
        transform_queue_size > 0,
        length(transform_queue_size) == 1,
        is.null(random_state) ||
            # is.integer(random_state)
            round(random_state) == random_state
            & random_state > 0
            & length(random_state) == 1,
        is.logical(angular_rp_forest),
        length(angular_rp_forest) == 1,
        is.numeric(target_n_neighbors),
        is.numeric(target_weight),
        length(target_weight) == 1
    )
}

test_that("umap works", {
    x <- matrix(rnorm(1e3), nrow = 100)
    expect_is(densmap(x), "matrix")
    Y_init <- prcomp(x)$x[, 1:2]
    expect_is(densmap(x, Y_init = Y_init), "matrix")
    expect_is(umap(x), "matrix")
})

---
title: "Introduction to densvis"
author:
  - name: Alan O'Callaghan
    email: alan.ocallaghan@outlook.com
package: densvis
output:
  BiocStyle::html_document:
    toc_float: yes
    fig_width: 10
    fig_height: 8
bibliography: library.bib
vignette: >
  %\VignetteIndexEntry{Introduction to densvis}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
    error = FALSE,
    warning=FALSE,
    message=FALSE,
    collapse = TRUE,
    comment = "#>"
)
library("BiocStyle")
```


# Introduction

Non-linear dimensionality reduction techniques such as t-SNE [@Maaten2008]
and UMAP [@McInnes2020] produce a low-dimensional embedding that summarises 
the global structure of high-dimensional data. These techniques can be 
particularly useful when visualising high-dimensional data in a biological 
setting.
However, these embeddings may not accurately represent the local density
of data in the original space, resulting in misleading visualisations where
the space given to clusters of data does not represent the fraction of the
high dimensional space that they occupy.
`densvis` implements the density-preserving objective function described by
[@Narayan2020] which aims to address this deficiency by including a 
density-preserving term in the t-SNE and UMAP optimisation procedures.
This can enable the creation of visualisations that accurately capture 
differing degrees of transcriptional heterogeneity within different cell 
subpopulations in scRNAseq experiments, for example.

# Setting up the data

We will illustrate the use of densvis
using simulated data.
We will first load the `densvis` and `Rtsne` libraries 
and set a random seed to ensure the t-SNE visualisation is reproducible
(note: it is good practice to ensure that a t-SNE embedding is robust
by running the algorithm multiple times).


```{r setup}
library("densvis")
library("Rtsne")
library("uwot")
library("ggplot2")
theme_set(theme_bw())
set.seed(14)
```

```{r data}
data <- data.frame(
    x = c(rnorm(1000, 5), rnorm(1000, 0, 0.2)),
    y = c(rnorm(1000, 5), rnorm(1000, 0, 0.2)),
    class = c(rep("Class 1", 1000), rep("Class 2", 1000))
)
ggplot() +
    aes(data[, 1], data[, 2], colour = data$class) +
    geom_point(pch = 19) +
    scale_colour_discrete(name = "Cluster") +
    ggtitle("Original co-ordinates")
```

# Running t-SNE

Density-preserving t-SNE can be generated using the `densne`
function. This function returns a matrix of t-SNE co-ordinates.
We set `dens_frac` (the fraction of optimisation steps that consider
the density preservation) and `dens_lambda` (the weight given to density
preservation relative to the standard t-SNE objective) each to 0.5.

```{r run-densne}
fit1 <- densne(data[, 1:2], dens_frac = 0.5, dens_lambda = 0.5)
ggplot() +
    aes(fit1[, 1], fit1[, 2], colour = data$class) +
    geom_point(pch = 19) +
    scale_colour_discrete(name = "Class") +
    ggtitle("Density-preserving t-SNE") +
    labs(x = "t-SNE 1", y = "t-SNE 2")
```

If we run t-SNE on the same data, we can see that the density-preserving
objective better represents the density of the data, 

```{r run-tsne}
fit2 <- Rtsne(data[, 1:2])
ggplot() +
    aes(fit2$Y[, 1], fit2$Y[, 2], colour = data$class) +
    geom_point(pch = 19) +
    scale_colour_discrete(name = "Class") +
    ggtitle("Standard t-SNE") +
    labs(x = "t-SNE 1", y = "t-SNE 2")
```



# Running UMAP

A density-preserving UMAP embedding can be generated using the `densmap`
function. This function returns a matrix of UMAP co-ordinates. As with t-SNE,
we set `dens_frac` (the fraction of optimisation steps that consider
the density preservation) and `dens_lambda` (the weight given to density
preservation relative to the standard t-SNE objective) each to 0.5.

```{r run-densmap}
fit1 <- densmap(data[, 1:2], dens_frac = 0.5, dens_lambda = 0.5)
ggplot() +
    aes(fit1[, 1], fit1[, 2], colour = data$class) +
    geom_point(pch = 19) +
    scale_colour_discrete(name = "Class") +
    ggtitle("Density-preserving t-SNE") +
    labs(x = "t-SNE 1", y = "t-SNE 2")
```

If we run UMAP on the same data, we can see that the density-preserving
objective better represents the density of the data, 

```{r run-umap}
fit2 <- umap(data[, 1:2])
ggplot() +
    aes(fit2[, 1], fit2[, 2], colour = data$class) +
    geom_point(pch = 19) +
    scale_colour_discrete(name = "Class") +
    ggtitle("Standard t-SNE") +
    labs(x = "t-SNE 1", y = "t-SNE 2")
```


# Session information {.unnumbered}

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/densmap.R
\name{umap}
\alias{umap}
\alias{densmap}
\title{Density-preserving and other implementations of UMAP}
\usage{
umap(
  x,
  n_components = 2L,
  dens_frac = 0.3,
  dens_lambda = 0.1,
  dens_var_shift = 0.1,
  n_neighbors = 30L,
  metric = "euclidean",
  densmap = FALSE,
  n_epochs = 750L,
  learning_rate = 1,
  init = c("spectral", "random"),
  Y_init = NULL,
  min_dist = 0.1,
  spread = 1,
  low_memory = FALSE,
  set_op_mix_ratio = 1,
  local_connectivity = 1L,
  repulsion_strength = 1,
  negative_sample_rate = 5L,
  transform_queue_size = 4,
  random_state = NULL,
  angular_rp_forest = FALSE,
  target_n_neighbors = -1,
  target_weight = 0.5,
  disconnection_distance = NULL
)

densmap(...)
}
\arguments{
\item{x}{A numeric matrix or matrix-like object.}

\item{n_components}{The dimension of the space to embed
into. This defaults to 2 to provide easy visualization,
but can reasonably be set to any integer value in the
range 2 to 100.}

\item{dens_frac}{numeric; fraction of the iterations for
which the full objective function (including the
density-preserving term) is used. For the first
\code{1 - dens_frac} fraction of the iterations, only
the original t-SNE objective function is used.
Only takes effect when \code{densmap=TRUE}.}

\item{dens_lambda}{numeric; the relative importance of the
density-preservation term compared to the original t-SNE
objective function.
Only takes effect when \code{densmap=TRUE}.}

\item{dens_var_shift}{Regularization term added to the variance
of embedding local radius for stability (float,
non-negative); default 0.1.
Only takes effect when \code{densmap=TRUE}.}

\item{n_neighbors}{The size of local neighborhood
(in terms of number of neighboring sample points) used for
manifold approximation. Larger values result in more
global views of the manifold, while smaller values result
in more local data being preserved. In general values
should be in the range 2 to 100.}

\item{metric}{The metric to use to compute distances in
high dimensional space. If a string is passed it must match
one of:
\itemize{
\item "euclidean"
\item "manhattan"
\item "chebyshev"
\item "minkowski"
\item "canberra"
\item "braycurtis"
\item "mahalanobis"
\item "wminkowski"
\item "seuclidean"
\item "cosine"
\item "correlation"
\item "haversine"
\item "hamming"
\item "jaccard"
\item "dice"
\item "russelrao"
\item "kulsinski"
\item "rogerstanimoto"
\item "sokalmichener"
\item "sokalsneath"
\item "yule"
}}

\item{densmap}{For \code{umap}, control whether the density-preserving
UMAP algorithm described by Narayan et al. is used.}

\item{n_epochs}{The number of training epochs to be used
in optimizing the low dimensional embedding. Larger values
result in more accurate embeddings. If None is specified a
value will be selected based on the size of the input
dataset (200 for large datasets, 500 for small).
a valid predefined metric.}

\item{learning_rate}{The initial learning rate for the embedding optimization.}

\item{init}{How to initialize the low dimensional
embedding. Valid options:
\itemize{
\item "spectral": use a spectral embedding of the fuzzy 1-skeleton
\item "random": assign initial embedding positions at random.
}}

\item{Y_init}{Numeric matrix specifying the initial
locations of the objects in the embedding. If NULL,
random or spectral initialization will be used,
controlled by the \code{init} argument.}

\item{min_dist}{The effective minimum distance between
embedded points. Smaller values will result in a more
clustered/clumped embedding where nearby points on the
manifold are drawn closer together, while larger values
will result on a more even dispersal of points. The value
should be set relative to the spread value, which
determines the scale at which embedded points will be
spread out.}

\item{spread}{The effective scale of embedded points. In combination with
min_dist this determines how clustered/clumped the embedded points are.}

\item{low_memory}{For some datasets the nearest neighbor computation can
consume a lot of memory. If you find that UMAP is failing due to memory
constraints consider setting this option to True. This approach is more
computationally expensive, but avoids excessive memory use.}

\item{set_op_mix_ratio}{Interpolate between (fuzzy) union
and intersection as the set operation used to combine
local fuzzy simplicial sets to obtain a global fuzzy
simplicial sets. Both fuzzy set operations use the product
t-norm. The value of this parameter should be between 0.0
and 1.0; a value of 1.0 will use a pure fuzzy union, while
0.0 will use a pure fuzzy intersection.}

\item{local_connectivity}{The local connectivity required
– i.e. the number of nearest neighbors that should be
assumed to be connected at a local level. The higher this
value the more connected the manifold becomes locally. In
practice this should be not more than the local intrinsic
dimension of the manifold.}

\item{repulsion_strength}{Weighting applied to negative
samples in low dimensional embedding optimization. Values
higher than one will result in greater weight being given
to negative samples.}

\item{negative_sample_rate}{The number of negative samples
to select per positive sample in the optimization process.
Increasing this value will result in greater repulsive
force being applied, greater optimization cost, but
slightly more accuracy.}

\item{transform_queue_size}{For transform operations
(embedding new points using a trained model_ this will
control how aggressively to search for nearest neighbors.
Larger values will result in slower performance but more
accurate nearest neighbor evaluation.}

\item{random_state}{The seed used by the random number
generator.}

\item{angular_rp_forest}{Whether to use an angular random
projection forest to initialise the approximate nearest
neighbor search. This can be faster, but is mostly on
useful for metric that use an angular style distance such
as cosine, correlation etc. In the case of those metrics
angular forests will be chosen automatically.}

\item{target_n_neighbors}{The number of nearest neighbors
to use to construct the target simplcial set. If set to -1
use the n_neighbors value.}

\item{target_weight}{Weighting factor between data
topology and target topology. A value of 0.0 weights
entirely on data, a value of 1.0 weights entirely on
target. The default of 0.5 balances the weighting equally
between data and target.}

\item{disconnection_distance}{Numeric scalar.
If specified, UMAP will disconnect any vertices of distance greater than or
equal to disconnection_distance when approximating the manifold via our k-nn
graph. This is particularly useful in the case that you have a bounded
metric. The UMAP assumption that we have a connected manifold can be
problematic when you have points that are maximally different from all the
rest of your data. The connected manifold assumption will make such points
have perfect similarity to a random set of other points. Too many such
points will artificially connect your space.}

\item{...}{Passed from \code{densmap} to \code{umap}.}
}
\value{
A numeric matrix
}
\description{
Density-preserving and other implementations of UMAP
}
\examples{
set.seed(42)
x <- matrix(rnorm(200), ncol=2)
densmap(x)
}
\references{
Density-Preserving Data Visualization Unveils Dynamic Patterns of Single-Cell
Transcriptomic Variability
Ashwin Narayan, Bonnie Berger, Hyunghoon Cho;
bioRxiv (2020)
\url{doi:10.1101/2020.05.12.077776}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/densne.R
\name{densne}
\alias{densne}
\title{Density-preserving t-SNE}
\usage{
densne(
  X,
  dims = 2,
  perplexity = 50,
  theta = 0.5,
  check_duplicates = TRUE,
  pca = FALSE,
  initial_dims = 50,
  partial_pca = FALSE,
  pca_center = TRUE,
  pca_scale = FALSE,
  verbose = getOption("verbose", FALSE),
  max_iter = 1000,
  Y_init = NULL,
  stop_lying_iter = if (is.null(Y_init)) 250L else 0L,
  mom_switch_iter = if (is.null(Y_init)) 250L else 0L,
  momentum = 0.5,
  final_momentum = 0.8,
  eta = 200,
  exaggeration_factor = 12,
  dens_frac = 0.3,
  dens_lambda = 0.1,
  num_threads = 1,
  normalize = TRUE
)
}
\arguments{
\item{X}{Input data matrix, where rows are observations and columns are
features.}

\item{dims}{Integer output dimensionality.}

\item{perplexity}{Perplexity parameter (should not be bigger than
3 * perplexity < nrow(X) - 1).}

\item{theta}{Speed/accuracy trade-off (increase for less
accuracy), set to 0.0 for exact TSNE}

\item{check_duplicates}{logical; Checks whether duplicates are present.
It is best to make sure there are no duplicates present and set this option
to FALSE, especially for large datasets (default: TRUE)}

\item{pca}{logical; Whether an initial PCA step should be performed
(default: FALSE).}

\item{initial_dims}{integer; the number of dimensions that should be retained
in the initial PCA step (default: 50)}

\item{partial_pca}{logical; Whether truncated PCA should be used to calculate
principal components (requires the irlba package). This is faster for large
input matrices (default: FALSE)}

\item{pca_center, pca_scale}{Controls whether to centre and scale the data
before applying PCA. Defaults: TRUE, FALSE.}

\item{verbose}{Logical; Whether progress updates should be printed}

\item{max_iter}{integer; Number of iterations}

\item{Y_init}{matrix; Initial locations of the objects. If NULL, random
initialization will be used}

\item{stop_lying_iter}{integer; Iteration after which the perplexities are no
longer exaggerated}

\item{mom_switch_iter}{integer; Iteration after which the final momentum is
used}

\item{momentum}{numeric; Momentum used in the first part of the optimization}

\item{final_momentum}{numeric; Momentum used in the final part of the
optimization}

\item{eta}{numeric; Learning rate}

\item{exaggeration_factor}{numeric; Exaggeration factor used to multiply the
affinities matrix P in the first part of the optimization}

\item{dens_frac}{numeric; fraction of the iterations for which the full
objective function (including the density-preserving term) is used.
For the first \code{1 - dens_frac} fraction of the iterations, only
the original t-SNE objective function is used.}

\item{dens_lambda}{numeric; the relative importanceof the
density-preservation term compared to the original t-SNE objective function.}

\item{num_threads}{Number of threads to be used for parallelisation.}

\item{normalize}{logical; Should data be normalized internally prior to
distance calculations with \code{\link[Rtsne]{normalize_input}}?}
}
\value{
A numeric matrix corresponding to the t-SNE embedding
}
\description{
Density-preserving t-SNE
}
\examples{
x <- matrix(rnorm(1e3), nrow = 100)
d <- densne(x, perplexity = 5)
plot(d)
}
\references{
Density-Preserving Data Visualization Unveils Dynamic Patterns of Single-Cell
Transcriptomic Variability
Ashwin Narayan, Bonnie Berger, Hyunghoon Cho;
bioRxiv (2020)
\url{doi:10.1101/2020.05.12.077776}
}
